/* 
 *
 * Created on 10. Dezember 2010, 15:59
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef ALEXEXCEPTION_H
#define	ALEXEXCEPTION_H

enum AlexExceptionKind {LockException, InvalidIdException, InvalidPropertyException,
        MemoryAllocFailedException};

/*! \brief AlexException is the class for all exceptions thrown in Alex
 *
 *
 */
class AlexException {
public:
    AlexException(int line, const char *filename, AlexExceptionKind kind){
            this->line = line;
            this->filename = filename;
            this->kind = kind;}
    AlexException(const AlexException& orig);
    ~AlexException(){};
private:
    int line;
    const char *filename;
    AlexExceptionKind kind;
};

#define ALEX_ELEMENT_LOCK_EXCEPTION AlexException(__LINE__, __FILE__, LockException)
#define ALEX_INVALID_ID_EXCEPTION AlexException(__LINE__, __FILE__, InvalidIdException)
#define ALEX_INVALID_PROPERTY_EXCEPTION AlexException(__LINE__, __FILE__, InvalidPropertyException)
#define ALEX_MEMORY_ALLOC_FAILED_EXCEPTION AlexException(__LINE__, __FILE__, MemoryAllocFailedException)
#endif	/* ALEXEXCEPTION_H */

