/* 
 * File:   AlexProperty.h
 * Author: klaus
 *
 * Created on 13. Dezember 2010, 15:14
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
**/

#ifndef ALEXPROPERTY_H
#define	ALEXPROPERTY_H
#include <map>
class AlexProperty {
public:
    AlexProperty() {}
    ~AlexProperty() {}
    AlexId propertyId;
    AlexReal getProperty(std::string prop){
        if( this->properties.find(prop)==this->properties.end()){
            throw(ALEX_INVALID_PROPERTY_EXCEPTION);
        }
        return this->properties[prop];
    }
    void setProperty(std::string prop, AlexReal value){
        this->properties[prop]=value;
    }
private:
    std::map<std::string, AlexReal> properties;

};

#endif	/* ALEXPROPERTY_H */

