/*
 *
 * Created on 9. Dezember 2010, 13:33
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef ALEXQUAD_H
#define	ALEXQUAD_H
#include <map>

/*! \brief AlexTria is the class to represent the finite elements of type
 *  tria.
 *
 * Trias are 2D finite elements defined by three points.
 */

class AlexQuad: public AlexElement {
public:
    AlexId n1, n2, n3, n4;
    bool containsNode(AlexId id){
        return ((n1==id)||(n2==id)||(n3==id));
    }
    AlexQuad(AlexId id, AlexId partId, AlexId propId, AlexId n1, AlexId n2, AlexId n3, AlexId n4):
        AlexElement(id, partId, propId){
        this->n1 = n1; this->n2=n2;
        this->n3=n3; this->n4=n4;

    }
};

class AlexQuads: public AlexElements<AlexQuad>{
public:
    void insertElement(AlexQuad *q){
        map[q->getId()]=q;
    }
};

//typedef std::map<AlexId, AlexQuad *>::iterator QuadssIterator;
#endif	/* ALEXQUAD_H */

