!
!> \file ModQuad.f95
!! \brief Quad functions
!
!> Modul: ModQuad
!> \author Klaus Ramstöck klra67@freenet.de
!> \date 26.03.2011
! (C) 2011 Klaus Ramstöck klra67@freenet.de
!
! This program is free software; you can redistribute it and/or modify it under the terms
!  of the GNU General Public License as published by the Free Software Foundation; either
!  version 3 of the License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
! without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this program;
!  if not, see <http://www.gnu.org/licenses/>.
!
MODULE ModQuad
    USE AlexTypes
    USE ModElements
    USE ModNodes
    USE Modvector
    implicit none
    private
    public warp
contains
    function warp(this, n, stat) result(w)
        TYPE(Element), intent(in) :: this
        TYPE(Nodes), intent(in) :: n
        INTEGER, intent(out), optional :: stat
        REAL(AlexRealKind) :: w
        TYPE(Node) :: n1, n2, n3, n4
        TYPE(Vector) :: v1, v2, v3, v4
        if (this % eType .ne. ETypeQuad) goto 8000
        n1 = getNode(n, this%nodeIds(1))
        n2 = getNode(n, this%nodeIds(2))
        n3 = getNode(n, this%nodeIds(3))
        n4 = getNode(n, this%nodeIds(4))
        v1 = distv(n1, n2)
        v2 = distv(n1, n4)
        v3 = distv(n3, n4)
        v4 = distv(n3, n2)
        v1 = fncross(v1,v2)
        call normalize(v1)
        v3 = fncross(v3, v4)
        w = norm(fncross(v1, v3))
        goto 9000
   8000 continue
        if(present(stat)) then
            stat = EBadType
            go to 9000
        ELSE
           print *, "ModQuad::warp: expected type ", ETypeQuad, " but got ", this%eType
           stop
        END IF
   9000 continue
    END FUNCTION warp
END MODULE ModQuad