!
! File:   ListOpsUnit.f95
! Author: klaus
!
! Created on 22. März 2011, 09:44
!
! This program is free software; you can redistribute it and/or modify it under the terms
!  of the GNU General Public License as published by the Free Software Foundation; either
!  version 3 of the License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
! without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this program;
!  if not, see <http://www.gnu.org/licenses/>.

MODULE ListOpsUnit
    USE AlexTypes
    USE ListOps
    USE FUNIT
    IMPLICIT NONE
    PRIVATE

    PUBLIC :: ListOpsUnitSetup
    PUBLIC :: ListOpsUnitTests
    PUBLIC :: ListOpsUnitTearDown

    INTEGER(AlexIdKind) :: list(5) = (/ 5, 4, 3, 2, 1 /)

CONTAINS
    SUBROUTINE ListOpsUnitSetup
        print *, "Testing ListOps"
    END SUBROUTINE ListOpsUnitSetup


    SUBROUTINE ListOpsUnitTests

        call SetUpTest("ListSort")
        call TestListSort

        call SetUpTest("ListFind")
        call TestListFind


    end SUBROUTINE ListOpsUnitTests

    SUBROUTINE ListOpsUnitTearDown
        print *, "End Testing ModVectorUnit"
    end SUBROUTINE ListOpsUnitTearDown

    SUBROUTINE TestListSort
        integer :: i
        integer(AlexIdKind)::sz=size(list)
        print '(A,I3,I3,I3,I3,I3)', "List presort:", int(list(:))
        call ListSort(sz, getter, swap)
        print '(A,I3,I3,I3,I3,I3)', "List postsort:", list(:)
        do i = 1, size(list) - 1, 1
            call AssertEquals(.true., list(i) .lt. list(i + 1), "TestListSort")
        end do
    end SUBROUTINE

    SUBROUTINE TestListFind
        integer(AlexIdKind)::i,sz=size(list)
        do i = 1, size(list)
            call AssertEquals(i, ListFind(i, sz, getter), "TestListFind")
        end do
            call AssertEquals(i, ListFind(i+1, sz, getter), "TestListFind-mustfail")
    end SUBROUTINE

     SUBROUTINE Swap(i, j)
        INTEGER(AlexIdKind), intent(in) :: i, j
        INTEGER(AlexIdKind) :: tmp
        tmp = list(i)
        list(i) = list(j)
        list(j) = tmp
        !print '(A,I2,I2,AI3,I3,I3,I3,I3)', "List swapped ", i-1,j-1,":",list(:)
    END SUBROUTINE Swap

    FUNCTION getter(i)
        INTEGER(AlexIdKind), intent(in) :: i
        INTEGER(AlexIdKind) :: getter
        getter = list(i)
    END FUNCTION getter

END MODULE ListOpsUnit
