!     
! File:   ModVectorUnit.f95
! Author: klaus
!
! Created on 22. März 2011, 09:44
! (C) 2011 Klaus Ramstöck klra67@freenet.de

! This program is free software; you can redistribute it and/or modify it under the terms
!  of the GNU General Public License as published by the Free Software Foundation; either
!  version 3 of the License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
! without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this program;
!  if not, see <http://www.gnu.org/licenses/>.

MODULE ModVectorUnit
    USE ModVector
    USE FUNIT
    IMPLICIT NONE
    PRIVATE

    PUBLIC ModVectorUnitSetup, ModVectorUnitTests, ModVectorUnitTearDown
    TYPE(Vector) :: v1, v2, v3

CONTAINS
    SUBROUTINE ModVectorUnitSetup
        print *, "Testing ModVectorUnit"
    END SUBROUTINE ModVectorUnitSetup


    SUBROUTINE ModVectorUnitTests

        call SetUpTest("Add")
        call TestAdd

        call SetUpTest("Sub")
        !call TestSub

    end SUBROUTINE ModVectorUnitTests

    SUBROUTINE ModVectorUnitTearDown
        print *, "End Testing ModVectorUnit"
    end SUBROUTINE ModVectorUnitTearDown

    SUBROUTINE TestAdd
        v1 = Vector(1.,2.,3.)
        v2 = Vector(4.,5.,6.)
        v3 = Vector(5.,7.,9.)
        call Add(v1,v2)
        call AssertEquals(0.0_real8, dble(norm(fnsub(v1,v3))), eps8)
    END SUBROUTINE TestAdd
    
END MODULE ModVectorUnit
