/*
 * Elements.java - generic Container Class for all Elements
 * 
 * Klaus Ramstöck, 2011-03-12 klra67@freenet.de
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;
import java.util.*;

/**
 *
 * @param <E extends Element> Element type for container
 * @author Klaus Ramstöck
 */
public class Elements<E extends Element> 
        {
    HashMap<Long,E> e;

    /**
     * Construct element map
     */
    public Elements(){ e = new HashMap<Long, E>();}

    /**
     * return the entrySet to loop over all entries
     * @return entrySet
     */
    public Set<Map.Entry<Long, E>> entrySet(){
        return e.entrySet();
    }

    /**
     *
     * @param e1 Element to be inserted
     */
    public void insert(E e1) {
          e.put(e1.getId(), e1);
    }

    /**
     * get Element by id
     * @param id
     * @return
     */
    public E get(long id){
        return e.get(id);
    }

}