/*
 * Nodes.java - Container for Nodes
 *
 *
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;
import java.util.*;

/**
 * Nodes - Container class for nodes
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class Nodes 
        {
    HashMap<Long,Node> n;

    /**
     * Initialize container
     */
    public Nodes(){n = new HashMap<Long,Node>();}

    /**
     * Get a node by id
     * @param id
     * @return Node n
     */
    public Node get(long id){ return n.get(id);}

    /**
     * Iterator for container
     * @return Iterator<Map.Entry<Long,Node>>
     */
     public Set<Map.Entry<Long, Node>> entrySet(){
         return n.entrySet();
     }
    /**
     * Insert a node
     * @param Node n1
     */
    public void insert(Node n1) {
          n.put(n1.getId(), n1);
    }

    /**
     * Helper class to construct a node array
     * @param n1 node1
     * @param n2 node2
     * @param n3 node3
     * @return
     */
    public static long[] nodeArray(long n1, long n2, long n3){
        long nodea[] = new long[3];
        nodea[0] = n1; nodea[1]=n2; nodea[2]=n3;
        return nodea;
    }

    /**
     * Helper class to construct a node array
     * @param n1 node1
     * @param n2 node2
     * @param n3 node3
     * @param n4 node4
     * @return
     */
    public static long[] nodeArray(long n1, long n2, long n3, long n4){
        long nodea[] = new long[4];
        nodea[0] = n1; nodea[1]=n2; nodea[2]=n3; nodea[3]=n4;
        return nodea;
    }
}
