/*
 * Properties.java - container class for properties
 *
 * Klaus Ramstöck, 2011-03-12 klra67@freenet.de
 *
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

package Alex.Elements;
import java.util.HashMap;
import java.util.Set;
import java.util.Map;

/**
 * Nodes - Container class for nodes
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class Properties
        {
    HashMap<Long,Property> p;

    /**
     * Initialize container
     */
    public Properties(){p = new HashMap<Long,Property>();}

    /**
     * Get a property card by id
     * @param id
     * @return Property p
     */
    public Property get(long id){ return p.get(id);}

    /**
     * Get a specific property from a card by id and name
     * @param id, name
     * @return Node n
     */
    public float get(long id, String name){ return p.get(id).getProp(name);}


    /**
     * Iterator for container
     * @return Iterator<Map.Entry<Long,Node>>
     */
     public Set<Map.Entry<Long, Property>> entrySet(){
         return p.entrySet();
     }
    /**
     * Insert a node
     * @param Node n1
     */
    public void insert(Property pp) {
          p.put(pp.getId(), pp);
    }

}
