/*
 * Tria.java - Class to represent tria elements
 *
 * Klaus Ramstöck, 2011-03-12 klra67@freenet.de
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

package Alex.Elements;

/**
 *
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class Tria extends Element{

    /**
     * Construct tria by propertyid, partid and node array
     * @param myPropertyId
     * @param myPartId
     * @param n[3]
     */
    public Tria(long myId, long myPropertyId, long myPartId, long n[]){
        super(myId, myPropertyId, myPartId, n);
        if(n.length != 3){
            throw new IllegalArgumentException();
        }
    }

    /**
     * Get normal to tria
     * @param Nodes n Geometry information
     * @return Vector n
     */
    public Vector normal(Nodes n){
        Vector v1 = n.get(this.n1()).distV(n.get(this.n2()));
        Vector v2 = n.get(this.n1()).distV(n.get(this.n3()));        
        return v1.cross(v2).normalize();
    }
}
