/*
 * ElementTest.java - test class Element
 *
 *
 * Copyright (C) 2010 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author klaus
 */
public class ElementTest {

    Element myElement ;
    Nodes myNodes;
    public ElementTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myNodes = new Nodes();
        Node n = new Node(4711, 1,2,3);
        myNodes.insert(n);
        n = new Node(4712, 4,5,6);
        myNodes.insert(n);
        n = new Node(4713, 0,0,0);
        myNodes.insert(n);
        long nids[] = Nodes.nodeArray(4711, 4712, 4713);
        myElement = new Element(1234, 1234, 4321, nids);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getPropertyId method, of class Element.
     */
    @Test
    public void testGetPropertyId() {
        System.out.println("getPropertyId");
        Element instance = myElement;
        long expResult = 1234L;
        long result = instance.getPropertyId();
        assertEquals(expResult, result);
    }

    /**
     * Test of setPropertyId method, of class Element.
     */
    @Test
    public void testSetPropertyId() {
        System.out.println("setPropertyId");
        long id = 9876L;
        Element instance = myElement;
        instance.setPropertyId(id);
        assertEquals(id, instance.getPropertyId());
    }

    /**
     * Test of getPartId method, of class Element.
     */
    @Test
    public void testGetPartId() {
        System.out.println("getPartId");
        Element instance = myElement;
        long expResult = 4321L;
        long result = instance.getPartId();
        assertEquals(expResult, result);
    }

    /**
     * Test of setPartId method, of class Element.
     */
    @Test
    public void testSetPartId() {
        System.out.println("setPartId");
        long id = 6666L;
        Element instance = myElement;
        instance.setPartId(id);
        assertEquals(id, instance.getPartId());
    }

    /**
     * Test of getVisibility method, of class Element.
     */
    @Test
    public void testGetVisibility() {
        System.out.println("getVisibility");
        Element instance = myElement;
        boolean expResult = true;
        boolean result = instance.getVisibility();
        assertEquals(expResult, result);
    }

    /**
     * Test of setVisibility method, of class Element.
     */
    @Test
    public void testSetVisibility() {
        System.out.println("setVisibility");
        boolean v = false;
        Element instance = myElement;
        instance.setVisibility(v);
        assertEquals(false, instance.getVisibility());
        instance.setVisibility(true);
    }

    /**
     * Test of toggleVisibility method, of class Element.
     */
    @Test
    public void testToggleVisibility() {
        System.out.println("toggleVisibility");
        Element instance = myElement;
        instance.toggleVisibility();
        assertEquals(false, instance.getVisibility());
        instance.setVisibility(true);
    }

    /**
     * Test of getNodes method, of class Element.
     */
    @Test
    public void testGetNodes() {
        System.out.println("getNodes");
        Element instance = myElement;
        long[] expResult = Nodes.nodeArray(4711, 4712, 4713);
        long[] result = instance.getNodes();
        for(int i=0; i<result.length; i++){
         assertEquals(expResult[i], result[i]);
        }
    }

    /**
     * Test of isReferer method, of class Element.
     */
    @Test
    public void testIsReferer() {
        System.out.println("isReferer");
        Element instance = myElement;
        assertEquals(true, instance.isReferer(4711));
        assertEquals(false, instance.isReferer(4710));

    }

}