/*
 * ElementTest.java - test class Element
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import java.util.*;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author klaus
 */
public class ElementsTest {

    Quad myQuad ;
    Nodes myNodes;
    Elements<Quad> myElements;

    public ElementsTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myElements = new Elements();
        myNodes = new Nodes();
        Node n = new Node(4711, 0,0,0);
        myNodes.insert(n);
        n = new Node(4712, 1,0,0);
        myNodes.insert(n);
        n = new Node(4713, 1,1,0);
        myNodes.insert(n);
        n = new Node(4714, 0,1,0);
        myNodes.insert(n);
        long nids[] = Nodes.nodeArray(4711, 4712, 4713, 4714);
        myQuad = new Quad(1234,1234, 4321, nids);
        myElements.insert(myQuad);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getElement method, of class Elements.
     */
    @Test
    public void testGetElement() {
        System.out.println("getElement");
        long id = 1234L;
        Elements instance = myElements;
        Element result = instance.get(id);
        assertEquals(id, result.getId());
    }

    /**
     * Test of insert method, of class Elements.
     */
    @Test
    public void testinsert() {
        System.out.println("insert");
        Quad q = new Quad(1111, 2222, 3333,Nodes.nodeArray(4711, 4712, 4713, 4714));
        Elements<Quad> instance = myElements;
        instance.insert(q);
        assertEquals(q, myElements.get(1111));
    }

    /**
     * Test of get method, of class Elements.
     */
    @Test
    public void testGet() {
        System.out.println("get");
        long id = 1234L;
        Elements<Quad> instance = myElements;
        Quad result = instance.get(id);
        assertEquals(id, result.getId());
    }

}