/*
 * NodeTest.java - test Node class
 *
 *
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class NodeTest {

    Node myNode;
    public NodeTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myNode = new Node(1234, 1,2,3);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getId method, of class Node.
     */
    @Test
    public void testGetId() {
        System.out.println("getId");
        Node instance = myNode;
        long expResult = 1234L;
        long result = instance.getId();
        assertEquals(expResult, result);
    }

    /**
     * Test of setId method, of class Node.
     */
    @Test
    public void testSetId() {
        System.out.println("setId");
        long myId = 4321L;
        Node instance = myNode;
        instance.setId(myId);
        assertEquals(myId, instance.getId());
        instance.setId(1234);
    }

    /**
     * Test of getPoint method, of class Node.
     */
    @Test
    public void testGetPoint() {
        System.out.println("getPoint");
        Node instance = myNode;
        Vector expResult = new Vector(1,2,3);
        Vector result = instance.getPoint();
        assertEquals(0.0, result.sub(expResult).norm(), 0.);
    }

    /**
     * Test of setPoint method, of class Node.
     */
    @Test
    public void testSetPoint() {
        System.out.println("setPoint");
        Vector v = new Vector(4,5,6);
        Node instance = myNode;
        instance.setPoint(v);
        assertEquals(0.0, instance.getPoint().sub(v).norm(), 0.);
        instance.setPoint(new Vector(1,2,3));
    }

    /**
     * Test of X method, of class Node.
     */
    @Test
    public void testX() {
        System.out.println("X");
        Node instance = myNode;
        float expResult = 1.0F;
        float result = instance.X();
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of Y method, of class Node.
     */
    @Test
    public void testY() {
        System.out.println("Y");
        Node instance = myNode;
        float expResult = 2.0F;
        float result = instance.Y();
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of Z method, of class Node.
     */
    @Test
    public void testZ() {
        System.out.println("Z");
        Node instance = myNode;
        float expResult = 3.0F;
        float result = instance.Z();
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of setX method, of class Node.
     */
    @Test
    public void testSetX() {
        System.out.println("setX");
        float xx = 4.0F;
        Node instance = myNode;
        instance.setX(xx);
        assertEquals(xx, instance.X(), 0.0);
        instance.setX(1);
    }

    /**
     * Test of setY method, of class Node.
     */
    @Test
    public void testSetY() {
        System.out.println("setY");
        float yy = 4.0F;
        Node instance = myNode;
        instance.setY(yy);
        assertEquals(yy, instance.Y(), 0.0);
        instance.setY(2);
    }

    /**
     * Test of setZ method, of class Node.
     */
    @Test
    public void testSetZ() {
        System.out.println("setZ");
        float zz = 4.0F;
        Node instance = myNode;
        instance.setZ(zz);
        assertEquals(zz, instance.Z(), 0.0);
        instance.setZ(3);
    }

    /**
     * Test of dist method, of class Node.
     */
    @Test
    public void testDist() {
        System.out.println("dist");
        Node n = new Node(2222, 4,5,6);
        Node instance = myNode;
        double expResult = Math.sqrt(3*3*3);
        double result = instance.dist(n);
        assertEquals(expResult, result, 0.0);
    }

}