/*
 * NodesTest.java - test Nodes container
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import java.util.Iterator;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class NodesTest {

    Node myNode;
    Nodes myNodes;
    public NodesTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myNode = new Node(1234, 1,2,3);
        myNodes = new Nodes();
        myNodes.insert(myNode);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getElement method, of class Nodes.
     */
    @Test
    public void testGetElement() {
        System.out.println("getElement");
        long id = 1234L;
        Nodes instance = myNodes;
        Node result = instance.get(id);
        assertEquals(1234, result.getId());
    }

    /**
     * Test of insert method, of class Nodes.
     */
    @Test
    public void testinsert() {
        System.out.println("insert");
        Node n1 = new Node(666, 4,5,6);
        Nodes instance = myNodes;
        instance.insert(n1);
        assertEquals(n1, instance.get(666));
    }

    /**
     * Test of get method, of class Nodes.
     */
    @Test
    public void testGet() {
        System.out.println("get");
        long id = 1234L;
        Nodes instance = myNodes;
        Node expResult = myNode;
        Node result = instance.get(id);
        assertEquals(expResult, result);
    }

}