/*
 * 
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import java.util.Set;
import java.util.Map;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author klaus
 */
public class PropertiesTest {

    Property myProperty;
    Properties myProperties;

    public PropertiesTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myProperty = new Property(1234);
        myProperty.setProp("a", 1.F);
        myProperties = new Properties();
        myProperties.insert(myProperty);
     }

    @After
    public void tearDown() {
    }

    /**
     * Test of get method, of class Properties.
     */
    @Test
    public void testGet_long() {
        System.out.println("get");
        long id = 1234L;
        Properties instance = myProperties;
        Property expResult = myProperty;
        Property result = instance.get(id);
        assertEquals(expResult, result);
    }

    /**
     * Test of get method, of class Properties.
     */
    @Test
    public void testGet_long_String() {
        System.out.println("get");
        long id = 1234L;
        String name = "a";
        Properties instance = myProperties;
        float expResult = 1.0F;
        float result = instance.get(id, name);
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of entrySet method, of class Properties.
     */
    @Test
    public void testEntrySet() {
        System.out.println("entrySet");
        Properties instance = myProperties;
        Property expResult = myProperty;
        for(Map.Entry<Long, Property> i : myProperties.entrySet()){
            Property result = i.getValue();
            assertEquals(expResult, result);
        }
    }

    /**
     * Test of insert method, of class Properties.
     */
    @Test
    public void testInsert() {
        System.out.println("insert");
        Property pp = new Property(4711);
        Properties instance = myProperties;
        instance.insert(pp);
        assertEquals(pp, instance.get(4711L));
    }

}