/*
 *
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

package Alex.Elements;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author klaus
 */
public class PropertyTest {

    private Property myProperty;

    public PropertyTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    myProperty = new Property(1234);
    myProperty.setProp("a", 1.F);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of setProp method, of class Property.
     */
    @Test
    public void testSetProp() {
        System.out.println("setProp");
        String name = "E-Modul";
        float prop = 1.23F;
        Property instance = myProperty;
        instance.setProp(name, prop);
        assertEquals(1.23F, instance.getProp(name), 0.0);
        instance.unsetProp(name);
    }

    /**
     * Test of unsetProp method, of class Property.
     */
    @Test
    public void testUnsetProp() {
        System.out.println("unsetProp");
        String name = "E-Modul";
        float prop = 1.23F;
        Property instance = myProperty;
        instance.unsetProp(name);
        instance.setProp(name, prop);
        instance.unsetProp(name);
        try{
            float x = instance.getProp(name);
            fail("Unset prop found");
        } catch (NullPointerException npe) {
            assertEquals(1,1);
        }
    }
    /**
     * Test of getProp method, of class Property.
     */
    @Test
    public void testGetProp() {
        System.out.println("getProp");
        String name = "a";
        Property instance = myProperty;
        float expResult = 1.0F;
        float result = instance.getProp(name);
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of getId method, of class Property.
     */
    @Test
    public void testGetId() {
        System.out.println("getId");
        Property instance = myProperty;
        long expResult = 1234L;
        long result = instance.getId();
        assertEquals(expResult, result);
    }

    /**
     * Test of setId method, of class Property.
     */
    @Test
    public void testSetId() {
        System.out.println("setId");
        long id = 4711L;
        Property instance = myProperty;
        instance.setId(id);
        assertEquals(id, instance.getId());
    }

}