/*
 * TriaTest.java - test Tria Elements
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */

package Alex.Elements;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class TriaTest {
    Tria myTria;
    Nodes myNodes;
    public TriaTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        myNodes = new Nodes();
        Node n = new Node(4711, 0,0,0);
        myNodes.insert(n);
        n = new Node(4712, 1,0,0);
        myNodes.insert(n);
        n = new Node(4713, 0,1,0);
        myNodes.insert(n);
        long nids[] = Nodes.nodeArray(4711, 4712, 4713);
        myTria = new Tria(1234,1234, 4321, nids);
    }

    @After
    public void tearDown() {
    }

    @Test
    public void testNormal() {
        System.out.println("normal");
        Tria instance = myTria;
        Vector expResult = new Vector(0,0,1);
        Vector result = instance.normal(myNodes);
        System.out.println(result);
        assertEquals(0.0, result.sub(expResult).norm(), 0.0);

    }

}