/*
 * VectorTest.java - test 3D Vector class
 *
 * Copyright (C) 2011 Klaus Ramstöck klra67@freenet.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 *  of the GNU General Public License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 *  if not, see <http://www.gnu.org/licenses/>.
 *
 */


package Alex.Elements;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Klaus Ramstöck klra67@freenet.de
 */
public class VectorTest {

    public VectorTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of add method, of class Vector.
     */
    @Test
    public void testAdd() {
        System.out.println("add");
        Vector b = new Vector(1,2,3);
        Vector instance = new Vector(4,5,6);
        Vector expResult = new Vector(5,7,9);
        Vector result = instance.add(b);
        assertEquals(expResult.sub(result).norm(), 0.0, 0.0);
    }

    /**
     * Test of sub method, of class Vector.
     */
    @Test
    public void testSub() {
        System.out.println("sub");
        Vector b = new Vector(4,5,6);
        Vector instance = new Vector(1,2,3);
        Vector expResult = new Vector(3,3,3);
        Vector result = instance.sub(b);
        assertEquals(expResult.add(result).norm(), 0.0, 0.0);
    }

    /**
     * Test of dot method, of class Vector.
     */
    @Test
    public void testDot() {
        System.out.println("dot");
        Vector b = new Vector(1,2,3);
        Vector instance = new Vector(4,5,6);
        double expResult = 4+10+18;
        double result = instance.dot(b);
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of cross method, of class Vector.
     */
    @Test
    public void testCross() {
        System.out.println("cross");
        Vector b = new Vector(0,1,0);
        Vector instance = new Vector(1,0,0);
        Vector expResult = new Vector(0,0,1);
        Vector result = instance.cross(b);
        assertEquals(expResult.sub(result).norm(), 0.0, 0.0);
    }

    /**
     * Test of dist method, of class Vector.
     */
    @Test
    public void testDist() {
        System.out.println("dist");
        Vector b = new Vector(1,2,3);
        Vector instance = new Vector(4,5,6);
        double expResult = Math.sqrt(3*3*3);
        double result = instance.dist(b);
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of norm method, of class Vector.
     */
    @Test
    public void testNorm() {
        System.out.println("norm");
        Vector instance = new Vector(1,2,3);
        double expResult = Math.sqrt(1+4+9);
        double result = instance.norm();
        assertEquals(expResult, result, 0.0);
    }

}